% \newpage
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{figure}[!ht]
\renewcommand{\arraystretch}{4.5}
\tabcolsep=0pt
\begin{tabular}{c}
  \ebpverif{CONST}{{
      \Hypo{\code{{\resid=\{\St {\wedge} {\res}{=}{\const^{\tau}}\}}}}
      \Infer1{\code{\htriple{\St}{k^\tau}{\resid}}}
    }}
  \ebpverif{VAR}{{
      \Hypo{\code{\resid{=}\{\St{\wedge}\res{=}v\}}}
      \Infer1{\code{\htriple{\St}{v}{\resid}}}
    }}
  \ebpverif{LOCAL}{{
      \Hypo{\code{\htriple{\St}{e}{\resid} }}
      \Infer1{\code {\htriple{\St}{t~v;~e}{\exists\,v,v'\cdot \resid}}}
    }}
  \\
  \ebpverif{ASSIGN}{{
      \Hypo{\code{\htriple{\St}{e}{\resid_1}} }
      \Hypo{\code{\resid_2{=}\exists \res{\cdot}(\resid_1 {\wedge} v'{=}\res) }}
      \Infer2{\code{\htriple{\St}{v{:=}e}{\resid_2}}}
    }}
  \ebpverif{FIELD-READ}{{
      \Hypo{\code{\subtr{\St\,}{\node{v}{d}{v_1,..,v_n}}{\resid_1}}}
      \Hypo{\code{\resid_1{\neq}\emptyset}}
      \Hypo{\code{\fresh~v_1..v_n}}
      \Infer[no rule]3{\code{\resid_2 = \exists
          v_1..v_n{\cdot}(\resid_1\,{*}\,\node{v}{d}{v_1,..,v_n} \wedge \res{=}v_i)}}
      \Infer1 {\htriple{\St}{v.f_i}{\resid_2}}
    }}\\
  \ebpverif{NEW}{{
      \Hypo{\code{\resid{=}\{\St\,{*}\,{\node{\res}{d}{v_1,..,v_n}}\}}}
      \Infer1{\code{\htriple{\St}{\new~d(v_1,..,v_n)}{\resid}}}
    }}
  \ebpverif{FIELD-UPDATE}{{
      \Hypo{\code{\subtr{\St\,}{\node{v}{d}{v_1,..,v_n}}{\resid_1}}}
      \Hypo{\code{\resid_1{\neq}\emptyset}}
      \Hypo{\code{ \fresh~v_1..v_n }}
      \Infer[no rule]3{\code{\resid_2 = \exists
          v_1..v_n{\cdot}(\resid_1\,{*}\,\rho(\node{v'}{d}{v_1,..,v_n})) \quad \rho{=}[v_\mathrm{0}/v_i]}}
      \Infer1{\code{\htriple{\St}{v.f_i{:=}v_\mathrm{0}}{\resid_2}}}
    }}

\\
\ebpverif{RETURN}{{
\Hypo{\code{\htriple{\St}{e}{\resid_1}}}
% \Hypo{fresh~v}
\Hypo{\code{\resid{=}\exists v \cdot (\exists \res\cdot (\resid_1 \wedge v{=}\res)) }}
\Infer2{\code{\htriple{\St}{\btt{return} ~e}{\resid}}}
}}
\\
\ebpverif{IF}{{
    \Hypo{\code{\htriple{\St{\wedge}b}{e_1}{\resid_1} }}
    \Hypo{\code{\htriple{\St{\wedge}{\neg}b}{e_2}{\resid_2}}}
    \Infer2{\code{\htriple{\St}{\myif{b}{e_1}{e_2}}{\resid_1{\vee}\resid_2}}}
  }} \quad
\ebpverif{SEQ}{{
\Hypo{\code{\htriple{\St}{e_1}{\resid_1}}}
\Hypo{\code{\htriple{\resid_1}{e_2}{\resid_2}}}
\Infer2{\code{\htriple{\St}{e_1;e_2}{\resid_2}}}
}}\\[0.5em]
\ebpverif{METH-DEF}{{
    \Hypo{\code{{V{=}\{v_m,..,v_n\}}}}
    \Hypo{\code{{W{=}\{v' \mid v \in V\}}}}
    \Infer[no rule]2{\code{\forall i =1,..,p \cdot
        (~ \htriple{\pre^i\wedge \mathit{nochange}(V)}{e}{\resid^i_1}
        \quad \subtr{\exists {W}{\cdot}\resid^i_1\,}{\post^i}{\resid^i_2}
        \quad \resid^i_2{\neq}\emptyset )
      }}
    \Infer1{\code{
        \htripleS{\emp}
        {t~\mathit{mn}((\btt{ref}~
          t_j~v_j)_{j{=}1}^{m-1}{,}(t_j~v_j)_{j{=}m}^n)
          \{\btt{requires}~\pre^i~~{ensures}~\post^i\}_{i=1}^p
          \{e\}}
        {\resid} }}
  }}\\[1.5em]
\ebpverif{METH-CALL}{{
    \Hypo{\code{t~\mathit{mn}
        ((\btt{ref}~t_j~v_j^\mathrm{0})_{j{=}1}^{m-1}{,}(t_j~v_j^\mathrm{0})_{j{=}m}^n)
        ~\{\btt{requires}~\pre^i~~\btt{ensures}~\post^i\}_{i=1}^p~\{e\} \in \Prog}}
    \Infer[no rule]1{\code{ \rho{=}[v_j/v^\mathrm{0}_j]_{j=1}^n
        \qquad \forall i {=}1,..,p  \cdot  (\subtr{\St}{\rho\pre^i}{\resid_i})
        \qquad \resid = \bigcup^p_{i{=}1} (\resid_i * \rho\post^i)
        \qquad \resid\,{\neq}\,\emptyset }}
    \Infer1{\code{\htriple{\St}{\mathit{mn}(v_1,..,v_n)}{\resid}}}
  }}
\end{tabular}\vspace{3mm}
% \hrule
\caption{Forward Verification Rules}\label{fig.prelim_verification}
\end{figure}



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% \pagebreak
%%% Local Variables:
%%% mode: latex
%%% TeX-master: "../main"
%%% End:
